aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--.gitignore2
-rwxr-xr-xci/deploy.sh45
-rw-r--r--mcp/reclass/classes/cluster/all-mcp-arch-common/opnfv/runtime.yml14
-rw-r--r--mcp/reclass/classes/cluster/all-mcp-arch-common/opnfv/runtime.yml.j2 (renamed from mcp/reclass/classes/cluster/all-mcp-arch-common/opnfv/pod_config.yml)9
-rw-r--r--mcp/reclass/classes/cluster/all-mcp-arch-common/opnfv/runtime.yml.template14
-rw-r--r--mcp/scripts/globals.sh6
-rw-r--r--mcp/scripts/lib.sh56
-rw-r--r--mcp/scripts/virsh_net/net_internal.xml (renamed from mcp/scripts/net_internal.xml)0
-rw-r--r--mcp/scripts/virsh_net/net_mcpcontrol.xml.j2 (renamed from mcp/scripts/net_mcpcontrol.xml.template)5
-rw-r--r--mcp/scripts/virsh_net/net_mgmt.xml.j2 (renamed from mcp/scripts/net_mgmt.xml)9
-rw-r--r--mcp/scripts/virsh_net/net_public.xml.j2 (renamed from mcp/scripts/net_public.xml)9
11 files changed, 92 insertions, 77 deletions
diff --git a/.gitignore b/.gitignore
index 38b444007..0b00d554c 100644
--- a/.gitignore
+++ b/.gitignore
@@ -12,5 +12,5 @@
**/mcp/deploy/images/
**/mcp/scripts/mcp.rsa*
**/mcp/scripts/user-data.sh
-**/mcp/scripts/net_mcpcontrol.xml
+**/mcp/scripts/virsh_net/*.xml
**/mcp/scripts/*.img
diff --git a/ci/deploy.sh b/ci/deploy.sh
index b6ff801bd..20c002674 100755
--- a/ci/deploy.sh
+++ b/ci/deploy.sh
@@ -120,7 +120,6 @@ CI_DEBUG=${CI_DEBUG:-0}; [[ "${CI_DEBUG}" =~ (false|0) ]] || set -x
REPO_ROOT_PATH=$(readlink -f "$(dirname "${BASH_SOURCE[0]}")/..")
DEPLOY_DIR=$(cd "${REPO_ROOT_PATH}/mcp/scripts"; pwd)
STORAGE_DIR=$(cd "${REPO_ROOT_PATH}/mcp/deploy/images"; pwd)
-RECLASS_CLUSTER_DIR=$(cd "${REPO_ROOT_PATH}/mcp/reclass/classes/cluster"; pwd)
DEPLOY_TYPE='baremetal'
BR_NAMES=('admin' 'mgmt' 'private' 'public')
OPNFV_BRIDGES=('pxebr' 'mgmt' 'internal' 'public')
@@ -263,27 +262,12 @@ fi
# Clone git submodules and apply our patches
make -C "${REPO_ROOT_PATH}/mcp/patches" deepclean patches-import
-# Convert Pharos-compatible POD Descriptor File (PDF) to reclass model input
-PHAROS_GEN_CONFIG_SCRIPT="./pharos/config/utils/generate_config.py"
-PHAROS_INSTALLER_ADAPTER="./pharos/config/installers/fuel/pod_config.yml.j2"
-BASE_CONFIG_PDF="${BASE_CONFIG_URI}/labs/${TARGET_LAB}/${TARGET_POD}.yaml"
-BASE_CONFIG_IDF="${BASE_CONFIG_URI}/labs/${TARGET_LAB}/idf-${TARGET_POD}.yaml"
-LOCAL_PDF="${STORAGE_DIR}/$(basename "${BASE_CONFIG_PDF}")"
-LOCAL_IDF="${STORAGE_DIR}/$(basename "${BASE_CONFIG_IDF}")"
-LOCAL_PDF_RECLASS="${STORAGE_DIR}/pod_config.yml"
-rm -f "${LOCAL_PDF_RECLASS}"
-ln -sf "$(readlink -f "../config/labs/local")" "./pharos/labs/"
-if ! curl --create-dirs -o "${LOCAL_PDF}" "${BASE_CONFIG_PDF}"; then
- notify_e "[ERROR] Could not retrieve PDF (Pod Descriptor File)!"
-elif ! curl -o "${LOCAL_IDF}" "${BASE_CONFIG_IDF}"; then
- notify_e "[ERROR] Could not retrieve IDF (Installer Descriptor File)!"
-elif ! "${PHAROS_GEN_CONFIG_SCRIPT}" -y "${LOCAL_PDF}" \
- -j "${PHAROS_INSTALLER_ADAPTER}" > "${LOCAL_PDF_RECLASS}"; then
- notify_e "[ERROR] Could not convert PDF+IDF to reclass model input!"
-fi
+# Expand scenario files, pod_config based on PDF
+SCENARIO_DIR="$(readlink -f "../config/scenario")"
+do_templates "${REPO_ROOT_PATH}" "${STORAGE_DIR}" "${TARGET_LAB}" \
+ "${TARGET_POD}" "${BASE_CONFIG_URI}" "${SCENARIO_DIR}"
# Check scenario file existence
-SCENARIO_DIR="../config/scenario"
if [ ! -f "${SCENARIO_DIR}/${DEPLOY_TYPE}/${DEPLOY_SCENARIO}.yaml" ]; then
notify_e "[ERROR] Scenario definition file is missing!"
fi
@@ -293,6 +277,10 @@ if [ ! -f "${SCENARIO_DIR}/defaults-$(uname -i).yaml" ]; then
notify_e "[ERROR] Scenario defaults file is missing!"
fi
+# Expand jinja2 templates based on PDF data and env vars
+do_templates "${REPO_ROOT_PATH}" "${STORAGE_DIR}" "${TARGET_LAB}" \
+ "${TARGET_POD}" "${BASE_CONFIG_URI}"
+
# Get required infra deployment data
set +x
eval "$(parse_yaml "${SCENARIO_DIR}/defaults-$(uname -i).yaml")"
@@ -329,23 +317,6 @@ for sc in ${base_image_flavors}; do
done
virtual_repos_pkgs=${virtual_repos_pkgs%^}
-# Expand reclass and virsh network templates
-for tp in "${RECLASS_CLUSTER_DIR}/all-mcp-arch-common/opnfv/"*.template \
- net_*.template; do
- eval "cat <<-EOF
- $(<"${tp}")
- EOF" 2> /dev/null > "${tp%.template}"
-done
-
-# Convert Pharos-compatible PDF to reclass network definitions
-find "${RECLASS_CLUSTER_DIR}" -name '*.j2' | while read -r tp
-do
- if ! "${PHAROS_GEN_CONFIG_SCRIPT}" -y "${LOCAL_PDF}" \
- -j "${tp}" > "${tp%.j2}"; then
- notify_e "[ERROR] Could not convert PDF to reclass network defs!"
- fi
-done
-
# Determine 'admin', 'mgmt', 'private' and 'public' bridge names based on IDF
for ((i = 0; i < ${#BR_NAMES[@]}; i++)); do
br_jump=$(eval echo "\$parameters__param_opnfv_jump_bridge_${BR_NAMES[i]}")
diff --git a/mcp/reclass/classes/cluster/all-mcp-arch-common/opnfv/runtime.yml b/mcp/reclass/classes/cluster/all-mcp-arch-common/opnfv/runtime.yml
deleted file mode 100644
index 387b57f8b..000000000
--- a/mcp/reclass/classes/cluster/all-mcp-arch-common/opnfv/runtime.yml
+++ /dev/null
@@ -1,14 +0,0 @@
-##############################################################################
-# Copyright (c) 2017 Mirantis Inc., Enea AB and others.
-# All rights reserved. This program and the accompanying materials
-# are made available under the terms of the Apache License, Version 2.0
-# which accompanies this distribution, and is available at
-# http://www.apache.org/licenses/LICENSE-2.0
-##############################################################################
----
-parameters:
- _param:
- opnfv_salt_master_ip: 10.20.0.2
- opnfv_maas_mcp_address: 10.20.0.3
- opnfv_net_mcpcontrol: 10.20.0.0
- opnfv_net_mcpcontrol_mask: 255.255.255.0
diff --git a/mcp/reclass/classes/cluster/all-mcp-arch-common/opnfv/pod_config.yml b/mcp/reclass/classes/cluster/all-mcp-arch-common/opnfv/runtime.yml.j2
index d72df2eb6..d6f5aa965 100644
--- a/mcp/reclass/classes/cluster/all-mcp-arch-common/opnfv/pod_config.yml
+++ b/mcp/reclass/classes/cluster/all-mcp-arch-common/opnfv/runtime.yml.j2
@@ -1,12 +1,15 @@
##############################################################################
-# Copyright (c) 2017 Mirantis Inc., Enea AB and others.
+# Copyright (c) 2018 Mirantis Inc., Enea AB and others.
# All rights reserved. This program and the accompanying materials
# are made available under the terms of the Apache License, Version 2.0
# which accompanies this distribution, and is available at
# http://www.apache.org/licenses/LICENSE-2.0
##############################################################################
---
+{#- conf.MCPCONTROL_NET & co are mandatory, defaults are set via globals.sh #}
parameters:
_param:
- # NOTE: This file is overwritten at runtime by parsing the PDF.
- opnfv_use_pod_descriptor_file: true
+ opnfv_salt_master_ip: {{ conf.SALT_MASTER }}
+ opnfv_maas_mcp_address: {{ conf.MAAS_IP }}
+ opnfv_net_mcpcontrol: {{ conf.MCPCONTROL_NET }}
+ opnfv_net_mcpcontrol_mask: {{ conf.MCPCONTROL_PREFIX | netmask }}
diff --git a/mcp/reclass/classes/cluster/all-mcp-arch-common/opnfv/runtime.yml.template b/mcp/reclass/classes/cluster/all-mcp-arch-common/opnfv/runtime.yml.template
deleted file mode 100644
index 64f75350c..000000000
--- a/mcp/reclass/classes/cluster/all-mcp-arch-common/opnfv/runtime.yml.template
+++ /dev/null
@@ -1,14 +0,0 @@
-##############################################################################
-# Copyright (c) 2017 Mirantis Inc., Enea AB and others.
-# All rights reserved. This program and the accompanying materials
-# are made available under the terms of the Apache License, Version 2.0
-# which accompanies this distribution, and is available at
-# http://www.apache.org/licenses/LICENSE-2.0
-##############################################################################
----
-parameters:
- _param:
- opnfv_salt_master_ip: ${SALT_MASTER}
- opnfv_maas_mcp_address: ${MAAS_IP}
- opnfv_net_mcpcontrol: ${SALT_MASTER%.*}.0
- opnfv_net_mcpcontrol_mask: 255.255.255.0
diff --git a/mcp/scripts/globals.sh b/mcp/scripts/globals.sh
index ace1de3a1..8966a0a94 100644
--- a/mcp/scripts/globals.sh
+++ b/mcp/scripts/globals.sh
@@ -12,9 +12,13 @@ export CI_DEBUG=${CI_DEBUG:-0}; [[ "${CI_DEBUG}" =~ (false|0) ]] || set -x
export SSH_KEY=${SSH_KEY:-"/var/lib/opnfv/mcp.rsa"}
export SALT_MASTER=${INSTALLER_IP:-10.20.0.2}
export SALT_MASTER_USER=${SALT_MASTER_USER:-ubuntu}
+
+# Derived from INSTALLER_IP
+export MCPCONTROL_NET=${MCPCONTROL_NET:-${SALT_MASTER%.*}.0}
+export MCPCONTROL_PREFIX=${MCPCONTROL_PREFIX:-24}
export MAAS_IP=${MAAS_IP:-${SALT_MASTER%.*}.3}
-# Derivated from above global vars
+# Derived from above global vars, not overideable
export SSH_OPTS="-o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -i ${SSH_KEY}"
export SSH_SALT="${SALT_MASTER_USER}@${SALT_MASTER}"
diff --git a/mcp/scripts/lib.sh b/mcp/scripts/lib.sh
index d91dcc3e1..7920a4e0d 100644
--- a/mcp/scripts/lib.sh
+++ b/mcp/scripts/lib.sh
@@ -321,8 +321,9 @@ function create_networks {
virsh net-undefine "${net}"
fi
# in case of custom network, host should already have the bridge in place
- if [ -f "net_${net}.xml" ] && [ ! -d "/sys/class/net/${net}/bridge" ]; then
- virsh net-define "net_${net}.xml"
+ if [ -f "virsh_net/net_${net}.xml" ] && \
+ [ ! -d "/sys/class/net/${net}/bridge" ]; then
+ virsh net-define "virsh_net/net_${net}.xml"
virsh net-autostart "${net}"
virsh net-start "${net}"
fi
@@ -469,6 +470,55 @@ function do_sysctl_cfg {
function get_nova_compute_pillar_data {
local value=$(salt -C 'I@nova:compute and *01*' pillar.get _param:"${1}" --out yaml | cut -d ' ' -f2)
if [ "${value}" != "''" ]; then
- echo ${value}
+ echo "${value}"
fi
}
+
+function do_templates() {
+ local git_repo_root=$1; shift
+ local image_dir=$1; shift
+ local target_lab=$1; shift
+ local target_pod=$1; shift
+ local lab_config_uri=$1; shift
+ local scenario_dir=${1:-}
+
+ RECLASS_CLUSTER_DIR=$(cd "${git_repo_root}/mcp/reclass/classes/cluster"; pwd)
+ PHAROS_GEN_CFG="./pharos/config/utils/generate_config.py"
+ PHAROS_INSTALLER_ADAPTER="./pharos/config/installers/fuel/pod_config.yml.j2"
+ BASE_CONFIG_PDF="${lab_config_uri}/labs/${target_lab}/${target_pod}.yaml"
+ BASE_CONFIG_IDF="${lab_config_uri}/labs/${target_lab}/idf-${target_pod}.yaml"
+ LOCAL_PDF="${image_dir}/$(basename "${BASE_CONFIG_PDF}")"
+ LOCAL_IDF="${image_dir}/$(basename "${BASE_CONFIG_IDF}")"
+ LOCAL_PDF_RECLASS="${image_dir}/pod_config.yml"
+
+ # Two-stage expansion, first stage handles pod_config and scenarios only
+ if [ -n "${scenario_dir}" ]; then
+ # Make sample PDF/IDF available via default lab-config (pharos submodule)
+ ln -sf "$(readlink -f "../config/labs/local")" "./pharos/labs/"
+
+ # Expand scenario file and main reclass input (pod_config.yaml) based on PDF
+ if ! curl --create-dirs -o "${LOCAL_PDF}" "${BASE_CONFIG_PDF}"; then
+ notify_e "[ERROR] Could not retrieve PDF (Pod Descriptor File)!"
+ elif ! curl -o "${LOCAL_IDF}" "${BASE_CONFIG_IDF}"; then
+ notify_e "[ERROR] Could not retrieve IDF (Installer Descriptor File)!"
+ elif ! "${PHAROS_GEN_CFG}" -y "${LOCAL_PDF}" \
+ -j "${PHAROS_INSTALLER_ADAPTER}" > "${LOCAL_PDF_RECLASS}"; then
+ notify_e "[ERROR] Could not convert PDF+IDF to reclass model input!"
+ fi
+ template_dirs="${scenario_dir}"
+ template_err_str='Could not convert j2 scenario definitions!'
+ else
+ # Expand reclass and virsh network templates based on PDF + IDF
+ printenv | \
+ awk '/^(SALT|MCP|MAAS|CLUSTER).*=/ { gsub(/=/,": "); print }' >> "${LOCAL_PDF}"
+ template_dirs="${RECLASS_CLUSTER_DIR} virsh_net ./*j2"
+ template_err_str='Could not convert PDF to network definitions!'
+ fi
+ # shellcheck disable=SC2086
+ find ${template_dirs} -name '*.j2' | while read -r tp; do
+ # Jinja2 import does not allow '..' directory traversal
+ if ! "${PHAROS_GEN_CFG}" -y "${LOCAL_PDF}" -j "${tp}" > "${tp%.j2}"; then
+ notify_e "[ERROR] ${template_err_str}"
+ fi
+ done
+}
diff --git a/mcp/scripts/net_internal.xml b/mcp/scripts/virsh_net/net_internal.xml
index 8cf875e7c..8cf875e7c 100644
--- a/mcp/scripts/net_internal.xml
+++ b/mcp/scripts/virsh_net/net_internal.xml
diff --git a/mcp/scripts/net_mcpcontrol.xml.template b/mcp/scripts/virsh_net/net_mcpcontrol.xml.j2
index e0034fd16..95424db4e 100644
--- a/mcp/scripts/net_mcpcontrol.xml.template
+++ b/mcp/scripts/virsh_net/net_mcpcontrol.xml.j2
@@ -6,13 +6,14 @@
which accompanies this distribution, and is available at
http://www.apache.org/licenses/LICENSE-2.0
-->
+{#- conf.MCPCONTROL_NET & co are mandatory, defaults are set via globals.sh #}
<network>
<name>mcpcontrol</name>
<bridge name="mcpcontrol"/>
<forward mode="nat"/>
- <ip address="${SALT_MASTER%.*}.1" netmask="255.255.255.0">
+ <ip address="{{ conf.MCPCONTROL_NET | ipaddr_index(1) }}" netmask="{{ conf.MCPCONTROL_PREFIX | netmask }}">
<dhcp>
- <range start="${SALT_MASTER%.*}.2" end="${SALT_MASTER%.*}.254"/>
+ <range start="{{ conf.MCPCONTROL_NET | ipaddr_index(2) }}" end="{{ conf.MCPCONTROL_NET | ipaddr_index(254) }}"/>
</dhcp>
</ip>
</network>
diff --git a/mcp/scripts/net_mgmt.xml b/mcp/scripts/virsh_net/net_mgmt.xml.j2
index 4fbec712a..a558293fa 100644
--- a/mcp/scripts/net_mgmt.xml
+++ b/mcp/scripts/virsh_net/net_mgmt.xml.j2
@@ -6,8 +6,15 @@
which accompanies this distribution, and is available at
http://www.apache.org/licenses/LICENSE-2.0
-->
+{%- if conf.idf.net_config.mgmt is defined %}
+ {%- set mgmt_network = conf.idf.net_config.mgmt.network %}
+ {%- set mgmt_prefix = conf.idf.net_config.mgmt.mask %}
+{%- else %}
+ {%- set mgmt_network = '172.16.10.0' %}
+ {%- set mgmt_prefix = '24' %}
+{%- endif %}
<network>
<name>mgmt</name>
<bridge name="mgmt"/>
- <ip address="172.16.10.1" netmask="255.255.255.0"/>
+ <ip address="{{ mgmt_network | ipaddr_index(1) }}" netmask="{{ mgmt_prefix | netmask }}"/>
</network>
diff --git a/mcp/scripts/net_public.xml b/mcp/scripts/virsh_net/net_public.xml.j2
index d6df4aa30..e47f69bb4 100644
--- a/mcp/scripts/net_public.xml
+++ b/mcp/scripts/virsh_net/net_public.xml.j2
@@ -6,9 +6,16 @@
which accompanies this distribution, and is available at
http://www.apache.org/licenses/LICENSE-2.0
-->
+{%- if conf.idf.net_config.public is defined %}
+ {%- set public_network = conf.idf.net_config.public.network %}
+ {%- set public_prefix = conf.idf.net_config.public.mask %}
+{%- else %}
+ {%- set public_network = '10.16.0.0' %}
+ {%- set public_prefix = '24' %}
+{%- endif %}
<network>
<name>public</name>
<bridge name="public"/>
<forward mode="nat"/>
- <ip address="10.16.0.1" netmask="255.255.255.0" />
+ <ip address="{{ public_network | ipaddr_index(1) }}" netmask="{{ public_prefix | netmask }}"/>
</network>